/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2007-20013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.h 619 2014-03-18 06:10:27Z nmir-saito $
 */

/*
 * ꥢI/OǥХSIO˥ɥ饤СAT91SKYEYEѡ
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "at91skyeye.h"

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#define INHNO_SIO        IRQ_USART0   /* ߥϥɥֹ */
#define INTNO_SIO        IRQ_USART0   /* ֹ */
#define INTPRI_SIO       -2              /* ͥ */
#define INTATR_SIO       0U        /* ° */

/*
 *  ꥢI/Oݡȿ
 */
#define TNUM_SIOP		1		/* ݡȤ륷ꥢI/OݡȤο */


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND	1U		/* ǽХå */
#define SIO_RDY_RCV	2U		/* ΥХå */

/*
 * ͥ뵯ưΥѤνin usart.h
 */
extern  void at91skyeye_init_uart(void);

/*
 *  UARTΥݡ󥰽
 */
Inline void
at91skyeye_putc(char c)
{
    sil_wrw_mem((void *)USART0_THR, c);
}

/*
 *  SIOɥ饤Фν
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  SIOγߥϥɥ
 */
extern void sio_handler(void);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
